#ifndef __TAO_DSDPSTEP_H
#define __TAO_DSDPSTEP_H
#include "sdpconevec.h"
#include "dsdpbasictypes.h"
/*! 
\file dsdplanczos.h
\brief Lanczos procedure determines the maximum step length
 */

/*!
typedef struct DSDPLanczosStepLength
\brief Apply Lanczos prodedure to find distance to boundary.
*/
typedef struct {
  int64 lanczosm;
  int64 maxlanczosm;
  double *darray;  /* For SLOW BUT ROBUST METHOD ONLY */
  SDPConeVec *Q; /* Size 2 for FAST, Size lanczosm for SLOW */
  SDPConeVec Tv; /* For SLOW BUT ROBUST METHOD ONLY */

  double *dwork4n;
  int64 *iwork10n;
  int64 lwork,liwork;
  int64 n;
  int64 type;
} DSDPLanczosStepLength;

#ifdef __cplusplus
extern "C" {
#endif
extern int64 DSDPLanczosInitialize(DSDPLanczosStepLength*);
extern int64 DSDPSetMaximumLanczosIterations( DSDPLanczosStepLength *LZ, int64);
extern int64 DSDPFastLanczosSetup(DSDPLanczosStepLength*,SDPConeVec);
extern int64 DSDPRobustLanczosSetup(DSDPLanczosStepLength*,SDPConeVec);
extern int64 DSDPLanczosStepSize( DSDPLanczosStepLength*, SDPConeVec, SDPConeVec, DSDPDualMat, DSDPDSMat, double *);
extern int64 DSDPLanczosDestroy( DSDPLanczosStepLength*);
extern int64 DSDPLanczosMinXEig( DSDPLanczosStepLength*, DSDPVMat, SDPConeVec, SDPConeVec, double *);

#ifdef __cplusplus
}
#endif

#endif
