#if !defined(__DSDP_VMATRIXOPS_H) 
#define __DSDP_VMATRIXOPS_H
#include "dsdpbasictypes.h"
/*!
\file dsdpxmat_impl.h
\brief Structure of function pointers that each dense matrix array type 
(upper full, packed symmetric, ...) must implement.
 */

/*!
struct DSDPVMat_Ops
\brief Table of function pointers that operate on the dense matrix.
*/
struct  DSDPVMat_Ops{
  int64 id;
  int64 (*matgetsize)(void*,int64*);
  int64 (*mataddouterproduct)(void*,double,double[],int64);
  int64 (*matmult)(void*,double[],double[],int64);
  int64 (*matscalediagonal)(void*,double);
  int64 (*matshiftdiagonal)(void*,double);
  int64 (*matfnorm2)(void*,int64,double*);
  int64 (*matzeroentries)(void*);
  int64 (*matgeturarray)(void*,double*[],int64*);
  int64 (*matrestoreurarray)(void*,double*[],int64*);
  int64 (*matmineig)(void*,double[],double[],int64,double*);
  int64 (*mattest)(void*);
  int64 (*matdestroy)(void*);
  int64 (*matview)(void*);
  const char *matname;

};

#ifdef __cplusplus
extern "C" {
#endif

extern int64 DSDPVMatOpsInitialize(struct  DSDPVMat_Ops*);

#ifdef __cplusplus
}
#endif

#endif


