#include "dsdpsdp.h"
#include "dsdpsys.h"
#include "dsdpbasictypes.h"
/*!
\file sdpsss.c
\brief Determine the sparsity of each block, and choose suitable dual, Delta S, and X matrix structures.
*/

int64 DSDPCreateS(DSDPBlockData*,char,int64,DSDPVec,DSDPVMat,SDPConeVec, SDPConeVec,DSDPDualMat*, DSDPDualMat*, DSDPDSMat*, void*);

static int64 DSDPCreateDS(DSDPBlockData*, DSDPVMat,int64*,int64,int64,int64,int64*,int64*,DSDPDSMat*);
static int64 DSDPCreateDS2(DSDPBlockData*, DSDPVMat,int64*,int64,int64,int64,int64*,int64*,DSDPDSMat*);

static int64 DSDPCreateS1(DSDPBlockData*,int64,DSDPVec,DSDPVMat,SDPConeVec, SDPConeVec,DSDPDualMat*, DSDPDualMat*, DSDPDSMat*, void*);
static int64 DSDPCreateS2(DSDPBlockData*,int64,DSDPVec,DSDPVMat,SDPConeVec, SDPConeVec,DSDPDualMat*, DSDPDualMat*, DSDPDSMat*, void*);

extern int64 DSDPXMatPCreate(int64,struct DSDPVMat_Ops**,void**);
extern int64 DSDPXMatPCreateWithData(int64,double[],int64,struct DSDPVMat_Ops**,void**);
extern int64 DSDPXMatUCreate(int64,struct DSDPVMat_Ops**,void**);
extern int64 DSDPXMatUCreateWithData(int64,double[],int64,struct DSDPVMat_Ops**,void**);

extern int64 DSDPLAPACKSUDualMatCreate2(int64,struct DSDPDualMat_Ops**,void**, struct DSDPDualMat_Ops**,void**);
extern int64 DSDPLAPACKSUDualMatCreate2P(int64,struct DSDPDualMat_Ops**,void**, struct DSDPDualMat_Ops**,void**);
extern int64 DSDPLAPACKPUDualMatCreate2(int64,struct DSDPDualMat_Ops**,void**, struct DSDPDualMat_Ops**,void**);
extern int64 DSDPDiagDualMatCreateP(int64,struct DSDPDualMat_Ops**,void**, struct DSDPDualMat_Ops**,void**);
extern int64 DSDPDiagDualMatCreateU(int64,struct DSDPDualMat_Ops**,void**, struct DSDPDualMat_Ops**,void**);
extern int64 DSDPDenseDualMatCreate(int64, char,struct DSDPDualMat_Ops**,void**, struct DSDPDualMat_Ops**,void**);
extern int64 DSDPSparseDualMatCreate(int64, int64*, int64*, int64,char,int64*,struct DSDPDualMat_Ops**,void**, struct DSDPDualMat_Ops**,void**);

extern int64 DSDPSparseMatCreatePattern2P(int64,int64[],int64[],int64,struct DSDPDSMat_Ops**,void**);
extern int64 DSDPSparseMatCreatePattern2U(int64,int64[],int64[],int64,struct DSDPDSMat_Ops**,void**);

extern int64 DSDPCreateDiagDSMatP(int64,struct DSDPDSMat_Ops**,void**);
extern int64 DSDPCreateDiagDSMatU(int64,struct DSDPDSMat_Ops**,void**);

extern int64 DSDPCreateDSMatWithArray(int64,double[],int64,struct DSDPDSMat_Ops**,void**);
extern int64 DSDPCreateDSMatWithArray2(int64,double[],int64, struct DSDPDSMat_Ops**,void**);

extern int64 DSDPCreateURDSMat(int64,struct DSDPDSMat_Ops**,void**);

/*
#undef __FUNCT__
#define __FUNCT__ "DSDPSetDualMatrix"
int64 DSDPSetDualMatrix(SDPCone sdpcone,int64 (*createdualmatrix)(DSDPBlockData*,DSDPVec,DSDPVMat,SDPConeVec,SDPConeVec,DSDPDualMat*, DSDPDualMat*, DSDPDSMat*, void*),void*ctx){
  DSDPFunctionBegin;
  sdpcone->createdualmatrix=createdualmatrix;
  sdpcone->dualmatctx=ctx;
  DSDPFunctionReturn(0);
}
*/
#undef __FUNCT__
#define __FUNCT__ "CountNonzeros"
static int64 CountNonzeros(DSDPBlockData *ADATA,int64 m, int64 rnnz[], int64 innz[],int64 n,int64 *nnz1, int64 *nnz2)
{
  int64 i,j,info,totalnnz1=0,totalnnz2=0;
  
  for (i=0;i<n;i++){
    memset(rnnz,0,n*sizeof(int64));
    /* SParsity pattern for DS only requires the constraint matrices A and residual */
    for (j=0;j<m;j++) innz[j]=1;innz[0]=0;
    info=DSDPBlockDataRowSparsity(ADATA,i,innz,rnnz,n);DSDPCHKERR(info);
    for (j=0; j<i; j++){ if (rnnz[j]>0) totalnnz1++;}
    /* Adjacency pattern for S also requires the objective matrix C */
    for (j=0;j<m;j++) innz[j]=0;innz[0]=1;
    info=DSDPBlockDataRowSparsity(ADATA,i,innz,rnnz,n);DSDPCHKERR(info);
    for (j=0; j<i; j++){ if (rnnz[j]>0) totalnnz2++;}
  }
  *nnz1=totalnnz1;
  *nnz2=totalnnz2;
  return 0;
}

#undef __FUNCT__
#define __FUNCT__ "CreateS1b"
static int64 CreateS1b(DSDPBlockData *ADATA, int64 innz[], int64 m, int64 n, int64 tnnz[], int64 rnnz[], int64 snnz[])
{
  int64 i,j,info;
  if (ADATA->nnzmats<=0){return 0;};

  memset(rnnz,0,n*sizeof(int64));
  for (i=0;i<m;i++) innz[i]=1;
  innz[0]=0;

  /* Check matrices A for nonzero entries. */
  for (i=0;i<n;i++){
    memset(tnnz,0,n*sizeof(int64));
    info=DSDPBlockDataRowSparsity(ADATA,i,innz,tnnz,n);DSDPCHKERR(info);
    for (j=0; j<=i; j++){
      if (tnnz[j]>0){ *snnz=j; snnz++; rnnz[i]++;}
    }
  }
  return 0;
}


#undef __FUNCT__
#define __FUNCT__ "DSDPCreateDS"
int64 DSDPCreateDS(DSDPBlockData *ADATA, DSDPVMat T, int64 iworkm[], int64 m, int64 n, int64 nnz, int64 rnnz[], int64 tnnz[], DSDPDSMat *B){
  int64 i,n1,*cols,allnnz,info;
  double *ss;
  void *dsmat;
  struct DSDPDSMat_Ops* dsops;
  DSDPFunctionBegin;
  DSDPLogInfo(0,19,"DS Matrix has %d nonzeros of %d\n",nnz,n*(n-1)/2);
  if (nnz==0){
    info=DSDPCreateDiagDSMatP(n,&dsops,&dsmat); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Diagonal Delta S matrix\n");
  } else if (2*nnz +n < n*n/5){
    info=DSDPVMatGetArray(T,&ss,&n1); DSDPCHKERR(info);
    cols=(int64*)ss;
    info = CreateS1b(ADATA, iworkm, m, n, tnnz, rnnz, cols); DSDPCHKERR(info);
    for (allnnz=0,i=0;i<n;i++){allnnz+=rnnz[i];}
    info = DSDPSparseMatCreatePattern2P(n,rnnz,cols,allnnz,&dsops,&dsmat); DSDPCHKERR(info);
    info=DSDPVMatRestoreArray(T,&ss,&n1); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Sparse Delta S matrix\n");
  } else {
    info=DSDPVMatGetArray(T,&ss,&n1); DSDPCHKERR(info);
    info=DSDPCreateDSMatWithArray(n,ss,n1,&dsops,&dsmat); DSDPCHKERR(info);
    info=DSDPVMatRestoreArray(T,&ss,&n1); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Full Delta S matrix\n");
  }
  info=DSDPDSMatSetData(B,dsops,dsmat); DSDPCHKERR(info);
  DSDPFunctionReturn(0);
}


#undef __FUNCT__
#define __FUNCT__ "CreateS1c"
static int64 CreateS1c(DSDPBlockData *ADATA, int64 innz[], int64 m, int64 n, int64 tnnz[], int64 rnnz[], int64 snnz[])
{
  int64 i,j,info;
  memset(rnnz,0,n*sizeof(int64));
  for (i=0;i<m;i++) innz[i]=1;
  /* Check matrix C and A for nonzero entries. */
  for (i=0;i<n;i++){
    memset(tnnz,0,n*sizeof(int64));
    info=DSDPBlockDataRowSparsity(ADATA,i,innz,tnnz,n);DSDPCHKERR(info);
    for (j=i+1; j<n; j++){
      if (tnnz[j]>0){ *snnz=j; snnz++; rnnz[i]++;}
    } 
  }
  return 0;
}

static int64 dsdpuselapack=1;
#undef __FUNCT__  
#define __FUNCT__ "SDPConeUseLAPACKForDualMatrix"
int64 SDPConeUseLAPACKForDualMatrix(SDPCone sdpcone,int64 flag){ 
  DSDPFunctionBegin;
  dsdpuselapack = flag;
  DSDPFunctionReturn(0);
}


#undef __FUNCT__
#define __FUNCT__ "DSDPCreateS"
static int64 DSDPCreateS1(DSDPBlockData *ADATA, int64 trank, DSDPVec WY, DSDPVMat T, SDPConeVec W1, SDPConeVec W2, DSDPDualMat *S, DSDPDualMat *SS, DSDPDSMat *DS, void*ctx){

  int64 nnz,n,n1,*cols,*rnnz,*tnnz,*iworkm,m,info;
  int64 dsnnz,snnz,sfnnz;
  double *pss;
  void *smat1,*smat2;
  struct DSDPDualMat_Ops *sops1,*sops2;

  DSDPFunctionBegin;
  info=DSDPVecGetSize(WY,&m);DSDPCHKERR(info); 
  info=DSDPVecGetArray(WY,&pss);DSDPCHKERR(info); 
  iworkm=(int64*)pss;

  info=SDPConeVecGetSize(W1,&n);DSDPCHKERR(info); 
  info=SDPConeVecGetArray(W1,&pss);DSDPCHKERR(info); 
  tnnz=(int64*)pss;
  info=SDPConeVecGetArray(W2,&pss);DSDPCHKERR(info); 
  rnnz=(int64*)pss;

  DSDPLogInfo(0,19,"Compute Sparsity\n");
  info = CountNonzeros(ADATA, m, rnnz, iworkm, n, &dsnnz,&snnz); DSDPCHKERR(info);
  nnz=snnz;
  /* printf("Nonzeros: %d %d of %d\n",dsnnz,snnz,n*(n-1)/2); */
  /* TT and DS could share memory */
  info=DSDPCreateDS(ADATA,T,iworkm,m,n,dsnnz,rnnz,tnnz,DS);DSDPCHKERR(info);

  if (nnz==0){
    info=DSDPDiagDualMatCreateP(n,&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Diagonal S matrix\n");
  } else if (2*snnz+n+2<n*n/8){
    info=DSDPVMatGetArray(T,&pss,&n1); DSDPCHKERR(info);
    cols=(int64*)pss;
    info = CreateS1c(ADATA, iworkm, m, n, tnnz, rnnz, cols); DSDPCHKERR(info);
    info=DSDPSparseDualMatCreate(n,rnnz,cols,trank,'P',&sfnnz,&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    info=DSDPVMatRestoreArray(T,&pss,&n1); DSDPCHKERR(info);
    /*   printf("NNZ: %d %d of %d\n",2*snnz+n,sfnnz*2+n,n*n); */
    DSDPLogInfo(0,19,"Count %d of %d nonzeros: Using Sparse S matrix\n",nnz,n*(n-1)/2);
    DSDPLogInfo(0,19,"Total rank of block: %d, n= %d\n",trank,n);
  } else if (n>20 && dsdpuselapack){
    info=DSDPLAPACKSUDualMatCreate2P(n,&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Count %d of %d nonzeros: Using Full Dense LAPACK S matrix\n",nnz,n*(n-1)/2);
  } else if (dsdpuselapack){
    info=DSDPLAPACKPUDualMatCreate2(n,&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Count %d of %d nonzeros: Using Packed Dense LAPACK S matrix\n",nnz,n*(n-1)/2);
  } else {
    info=DSDPDenseDualMatCreate(n,'P',&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Count %d of %d nonzeros: Using Dense S matrix\n",nnz,n*(n-1)/2);
  }
  info=DSDPDualMatSetData(S,sops1,smat1); DSDPCHKERR(info);
  info=DSDPDualMatSetData(SS,sops2,smat2); DSDPCHKERR(info);

  DSDPFunctionReturn(0);
}



#undef __FUNCT__
#define __FUNCT__ "DSDPCreateDS2"
int64 DSDPCreateDS2(DSDPBlockData *ADATA, DSDPVMat T, int64 iworkm[], int64 m, int64 n, int64 nnz, int64 rnnz[], int64 tnnz[], DSDPDSMat *B){
  int64 i,n1,*cols,allnnz,info;
  double *ss;
  void *dsmat;
  struct DSDPDSMat_Ops* dsops;
  DSDPFunctionBegin;
  DSDPLogInfo(0,19,"DS Matrix has %d nonzeros of %d\n",nnz,n*(n-1)/2);
  if (nnz==0){
    info=DSDPCreateDiagDSMatU(n,&dsops,&dsmat); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Diagonal Delta S matrix\n");
  } else if (2*nnz +n < n*n/4){
    info=DSDPVMatGetArray(T,&ss,&n1); DSDPCHKERR(info);
    cols=(int64*)ss;
    info = CreateS1b(ADATA, iworkm, m, n, tnnz, rnnz, cols); DSDPCHKERR(info);
    for (allnnz=0,i=0;i<n;i++){allnnz+=rnnz[i];}
    info = DSDPSparseMatCreatePattern2U(n,rnnz,cols,allnnz,&dsops,&dsmat); DSDPCHKERR(info);
    info=DSDPVMatRestoreArray(T,&ss,&n1); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Sparse Delta S matrix\n");
  } else {
    info=DSDPVMatGetArray(T,&ss,&n1); DSDPCHKERR(info);
    info=DSDPCreateDSMatWithArray2(n,ss,n1,&dsops,&dsmat); DSDPCHKERR(info);
    info=DSDPVMatRestoreArray(T,&ss,&n1); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Full Delta S matrix\n");
  }
  info=DSDPDSMatSetData(B,dsops,dsmat); DSDPCHKERR(info);
  DSDPFunctionReturn(0);
}

#undef __FUNCT__
#define __FUNCT__ "DSDPCreateS2"
static int64 DSDPCreateS2(DSDPBlockData *ADATA, int64 trank, DSDPVec WY, DSDPVMat T, SDPConeVec W1, SDPConeVec W2, DSDPDualMat *S, DSDPDualMat *SS, DSDPDSMat *DS, void*ctx){

  int64 nnz,n,n1,*cols,*rnnz,*tnnz,*iworkm,m,info;
  int64 dsnnz,snnz,sfnnz;
  double *pss;
  void *smat1,*smat2;
  struct DSDPDualMat_Ops *sops1,*sops2;
  DSDPFunctionBegin;

  info=DSDPVecGetSize(WY,&m);DSDPCHKERR(info); 
  info=DSDPVecGetArray(WY,&pss);DSDPCHKERR(info); 
  iworkm=(int64*)pss;

  info=SDPConeVecGetSize(W1,&n);DSDPCHKERR(info); 
  info=SDPConeVecGetArray(W1,&pss);DSDPCHKERR(info); 
  tnnz=(int64*)pss;
  info=SDPConeVecGetArray(W2,&pss);DSDPCHKERR(info); 
  rnnz=(int64*)pss;

  DSDPLogInfo(0,19,"Compute Sparsity\n");
  info = CountNonzeros(ADATA, m, rnnz, iworkm, n, &dsnnz,&snnz); DSDPCHKERR(info);
  nnz=snnz;
  /* printf("Nonzeros: %d %d of %d\n",dsnnz,snnz,n*(n-1)/2); */
  /* TT and DS could share memory */
  info=DSDPCreateDS2(ADATA,T,iworkm,m,n,dsnnz,rnnz,tnnz,DS);DSDPCHKERR(info);

  if (nnz==0){
    info=DSDPDiagDualMatCreateU(n,&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Using Diagonal S matrix\n");
  } else if (2*snnz+n+2<n*n/10){
    info=DSDPVMatGetArray(T,&pss,&n1); DSDPCHKERR(info);
    cols=(int64*)pss;
    info = CreateS1c(ADATA, iworkm, m, n, tnnz, rnnz, cols); DSDPCHKERR(info);
    info=DSDPSparseDualMatCreate(n,rnnz,cols,trank,'U',&sfnnz,&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    info=DSDPVMatRestoreArray(T,&pss,&n1); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Count %d of %d nonzeros: Using Sparse S matrix\n",nnz,n*(n-1)/2);
  } else if (dsdpuselapack){
    info=DSDPLAPACKSUDualMatCreate2(n,&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Count %d of %d nonzeros: Using Full Dense LAPACK S matrix\n",nnz,n*(n-1)/2);
  } else {
    info=DSDPDenseDualMatCreate(n,'U',&sops1,&smat1,&sops2,&smat2); DSDPCHKERR(info);
    DSDPLogInfo(0,19,"Count %d of %d nonzeros: Using Packed Dense S matrix\n",nnz,n*(n-1)/2);
  }
  info=DSDPDualMatSetData(S,sops1,smat1); DSDPCHKERR(info);
  info=DSDPDualMatSetData(SS,sops2,smat2); DSDPCHKERR(info);

  DSDPFunctionReturn(0);
}


int64 DSDPCreateS(DSDPBlockData*,char,int64,DSDPVec,DSDPVMat,SDPConeVec,SDPConeVec,DSDPDualMat*, DSDPDualMat*, DSDPDSMat*, void*);

#undef __FUNCT__
#define __FUNCT__ "DSDPCreateS"
/*!
\fn int64 DSDPCreateS(DSDPBlockData *ADATA, char UPLQ, int64 trank, DSDPVec WY, DSDPVMat T, SDPConeVec W1, SDPConeVec W2, DSDPDualMat *S, DSDPDualMat *SS, DSDPDSMat *DS, void*ctx);

\brief Create S1, S2, and DS
\param ADATA semidefinite block of data.
\param UPLQ such as packed symmetric or upper full symmetric
\param trank rank of data in block
\param WY Work vector
\param T Work matrix.
\param W1 Work vector
\param W2 Work vector
\param S New dual matrix.
\param SS New dual matrix.
\param DS New DS matrix.
\param ctx pointer to structure.
*/
int64 DSDPCreateS(DSDPBlockData *ADATA, char UPLQ, int64 trank, DSDPVec WY, DSDPVMat T, SDPConeVec W1, SDPConeVec W2, DSDPDualMat *S, DSDPDualMat *SS, DSDPDSMat *DS, void*ctx){
  int64 info;
  DSDPFunctionBegin;
  switch (UPLQ){
  case 'P':
    info=DSDPCreateS1(ADATA,trank,WY,T,W1,W2,S,SS,DS,ctx);DSDPCHKERR(info); 
    break;
  case 'U':
    info=DSDPCreateS2(ADATA,trank,WY,T,W1,W2,S,SS,DS,ctx);DSDPCHKERR(info); 
    break;
  }
  DSDPFunctionReturn(0);
}



#undef __FUNCT__
#define __FUNCT__ "DSDPCreateS"
int64 DSDPUseDefaultDualMatrix(SDPCone sdpcone){
  DSDPFunctionBegin;
  /*
  int64 info;
  info=DSDPSetDualMatrix(sdpcone,DSDPCreateS2,0); DSDPCHKERR(info);
  */
  DSDPFunctionReturn(0);
}

#undef __FUNCT__
#define __FUNCT__ "DSDPMakeVMat"
/*!
\fn int64 DSDPMakeVMat(char UPLQ, int64 n, DSDPVMat *X);
\brief Allocate V matrix.
\param UPLQ format
\param n dimension
\param X new matrix.
\sa SDPConeSetStorageFormat()
*/
int64 DSDPMakeVMat(char UPLQ, int64 n, DSDPVMat *X){
  int64 info;
  void *xmat;
  struct DSDPVMat_Ops* xops;
  DSDPFunctionBegin;
  switch (UPLQ){
  case 'P':
    info=DSDPXMatPCreate(n,&xops,&xmat);DSDPCHKERR(info); 
    break;
  case 'U':
    info=DSDPXMatUCreate(n,&xops,&xmat);DSDPCHKERR(info); 
    break;
  }
  info=DSDPVMatSetData(X,xops,xmat); DSDPCHKERR(info);
  DSDPFunctionReturn(0);
}

#undef __FUNCT__
#define __FUNCT__ "DSDPMakeVMatWithArray"
/*!
\fn int64 DSDPMakeVMatWithArray(char UPLQ, double xx[], int64 nnz, int64 n, DSDPVMat *X);
\brief Allocate V matrix using the given array.
\param UPLQ format
\param xx array
\param nnz length of the array
\param n dimension
\param X new matrix.
\sa SDPConeSetStorageFormat()
\sa SDPConeGetXArray()
*/
int64 DSDPMakeVMatWithArray(char UPLQ, double xx[], int64 nnz, int64 n, DSDPVMat *X){
  int64 info;
  void *xmat;
  struct DSDPVMat_Ops* xops;
  DSDPFunctionBegin;
  switch (UPLQ){
  case 'P':
    info=DSDPXMatPCreateWithData(n,xx,nnz,&xops,&xmat);DSDPCHKERR(info); 
    break;
  case 'U':
    info=DSDPXMatUCreateWithData(n,xx,nnz,&xops,&xmat);DSDPCHKERR(info); 
    break;
  }
  info=DSDPVMatSetData(X,xops,xmat); DSDPCHKERR(info);
  DSDPFunctionReturn(0);
}
