#include "dsdpbasictypes.h"
#if !defined(__DSDP_SCHURMATRICES_H) 
#define __DSDP_SCHURMATRICES_H

/*!
\file dsdpschurmat_impl.h
\brief Function pointers that a Schur complement matrix (dense, sparse, parallel dense) must provide.
*/

struct  DSDPSchurMat_Ops{
  int64 id;
  int64 (*matzero)(void*);
  int64 (*matrownonzeros)(void*,int64,double*,int64*,int64);
  int64 (*mataddrow)(void*,int64,double,double[],int64);
  int64 (*mataddelement)(void*,int64,double);
  int64 (*matadddiagonal)(void*,double[],int64);
  int64 (*matshiftdiagonal)(void*,double);
  int64 (*matassemble)(void*);
  int64 (*matscaledmultiply)(void*,double[],double[],int64);
  int64 (*matmultr)(void*,double[],double[],int64);
  int64 (*matfactor)(void*,int64*);
  int64 (*matsolve)(void*,double[],double[],int64);
  int64 (*matsetup)(void*,int64);
  int64 (*pmatwhichdiag)(void*,double[],int64);
  int64 (*pmatonprocessor)(void*,int64,int64*);
  int64 (*pmatlocalvariables)(void*,double[],int64);
  int64 (*pmatreduction)(void*,double[],int64);
  int64 (*pmatdistributed)(void*,int64*);
  int64 (*matdestroy)(void*);
  int64 (*matview)(void*);
  const char *matname;
};

extern int64 DSDPSetSchurMatOps(DSDP,struct DSDPSchurMat_Ops*,void*);
extern int64 DSDPSchurMatOpsInitialize(struct DSDPSchurMat_Ops*);
extern int64 DSDPSparsityInSchurMat(DSDP,int64,int64[],int64);
#endif


