#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "dsdpbasictypes.h"

typedef enum {
  CfcOk=0,
  CfcSpace,   /* fail to allocate required space */
  CfcIndef    /* indefinity is detected          */
} cfc_sta;

typedef struct {
  int64    mrow;     /* number of rows allocated                    */
  int64    nrow;     /* number of rows used                         */
    
  int64    snnz;     /* number of indices for nonzeros in S         */
  int64    *shead;   /* position of first nonzero in row i of S     */
  int64    *ssize;   /* number of non-zeros in row i of S below     */
                   /* the diagonal                                */
  int64    *ssub;    /* column index buffer for non-zeros in S      */
  double *diag;    /* diagonal matrix D in the factorization      */
  double *sqrtdiag;/* sqrt o diagonal matrix D in the factorization */
    
  int64    unnz;     /* number of nonzeros in the upper factor      */
  int64    ujnz;     /* number of column indices in the compressed  */
                     /* indices buffer ujsub                        */ 
  int64    *ujbeg;   /* beginning position of indices in row i of U */
  int64    *uhead;   /* position of first nonzero in row i of U     */
  int64    *ujsze;   /* number of indices in row i of U             */ 
  int64    *usub;    /* compressed column index buffer of U         */
  double *uval;    /* nonzero values in factor U                  */
    
  int64    *perm;    /* permutation order                           */
  int64    *invp;    /* inverse order of perm                       */
    
  int64    nsnds;    /* number of supernodes                        */
  int64    *subg;    /* index of the first column in supernode i    */
  int64    ndens;    /* numer of dense rows                         */
  int64    nsndn;    /* number supernodes in dense rows             */
  int64    *dhead;   /* pointer first column in each dense row      */
  int64    *dsub;    /* indices in dense rows                       */
  int64    *dbeg;    /* beginning of column index                   */ 
  int64    sdens;    /* separate dense row                          */

  int64    alldense;

  double tolpiv;
  int64 cachesize;
  int64 cacheunit;

  /* New */
  int64 n;
  int64 *iw;
  double *rw;
  int64 factor;
} chfac;


typedef struct {
    int64 idep;
    int64 last;
    int64 most;
    int64 cure;
    int64 loca;
    int64 lowp;
    int64 ntot;
    
    int64 *head;
    int64 *port;
    int64 *fwrd;
    int64 *bwrd;
  } xlist;
  
typedef struct {
    int64 nnod;
    int64 nn0;
    int64 raft;
    int64 head;
    int64 last;
    int64 ntot;
    
    int64 *adjn;
    int64 *rbeg;
    int64 *rexs;
    int64 *rlen;
    int64 *rend;
    int64 *pres;
    int64 *succ;
  } order;

typedef enum {
  OptFound=0,
  SysError=100,
  OutOfSpc,CholErr
} xcode;

#if !defined (min)
#define min(a,b) ((a <= b)? (a) : (b))
#endif
#if !defined (max)
#define max(a,b) ((a >= b)? (a) : (b))
#endif
#if !defined (sign)
#define sign(a) ((a<0)? (-1) : (1))
#endif
#if !defined (TRUE)
#define TRUE 1
#endif
#if !defined (FALSE)
#define FALSE 0
#endif

#include "sdpfun.h"
