#include "numchol.h"
#include <stdio.h>

int64 ExitProc(int64,char *);

void iZero(int64 n,
           int64 *x,
           int64 *s)
{
  int64 i;

  if (s) {
    for(i=0; i<n; ++i)
      x[s[i]]=0;
  }
  else
    memset(x,0,n*sizeof(int64));
} /* iZero */

void iSet(int64 n,
          int64 a,
          int64 *x,
          int64 *id)
{
  int64 i;

  if (!id)
    for(i=0; i<n; ++i)
      x[i]=a;
  else
    for(i=0; i<n; ++i)
      x[id[i]]=a;
} /* iSet */

void iSwap(int64 i1,
           int64 i2,
           int64 *v)
{
  int64 temp;

  if (i1<0||i2<0)
    ExitProc(SysError,(char *)"index error");
  temp  = v[i1];
  v[i1] = v[i2];
  v[i2] = temp;
} /* iSwap */

void iCopy(int64 n,
           int64 *s,
           int64 *d)
{
  memcpy(d,s,n*sizeof(int64));
} /* iCopy */

int64 iSum(int64 n,
         int64 *x)
{
  int64 i,sum=0;
  
  for (i=0; i<n; i++)
    sum+=x[i];
    
  return sum;
} /* iSum */

void dCopy(int64    n,
           double *s,
           double *d)
{
  if (n) memcpy(d,s,n*sizeof(double));
} /* dCopy */

void dCat(int64    n,
          int64    *ix,
          double *s,
          double *d)
{
  int64 i;
  
  for (i=0; i<n; i++) {
    d[i]=s[ix[i]];
    s[ix[i]]=0.0;
  }
} /* dCat */

double dDot(double *x,
            double *y,
            int64    n)
{
  int64    i;
  double r;
  
  r=0.0;
  for (i=0; i<n; i++)
    r+=x[i]*y[i];
  
  return r;
}/* dDot */

void plusXs(int64 n,
            int64 *x,
            int64 *s)
{
  int64 i;
  
  if (!s) {
    for (i=0; i<n; i++)
      x[i]++;
  }
  else {
    for (i=0; i<n; i++)
      x[s[i]]++;
  }
} /* plusXs */
