#include "dsdpbasictypes.h"
/*
 * common functions
 */
#if !defined (min)
#define min(a,b) ((a <= b)? (a) : (b))
#endif
#if !defined (max)
#define max(a,b) ((a >= b)? (a) : (b))
#endif
#if !defined (sign)
#define sign(a) ((a<0)? (-1) : (1))
#endif

/*
 * functions in sdpallo.c
 */
int64       iAlloc(int64,char*,int64**);
void      iFree(int64**);
int64       dAlloc(int64,char*,double**);
void      dFree(double**);
void      cFree(char**);
int64       LvalAlloc(chfac*,char*);
int64       CfcAlloc(int64,char*,chfac**);
void      CfcFree(chfac**);
int64       dPtAlloc(int64,char*,double ***); 
void      dPtFree(double***);

/* 
 * functions in sdpmain.c 
 */ 
void    GetUhat(chfac*,double*,double*);

/*
 * functions in sdpshut.c
 */
void    ShutDown(void);
int64     ExitProc(int64,char*);


/*
 * functions in sdplib.a
 */
void    DotProd(double*,chfac*);

void    ForwSubst(chfac*,double*,double*);
int64     iSum(int64,int64*);
void    dCopy(int64,double*,double*);
int64     ChlFact(chfac*,int64*,double*,int64);
void    ChlSolve(chfac*,double*,double*);
void    ChlSolveForward(chfac*, double*, double*);
void    ChlSolveBackward(chfac*, double*, double*);
int64     SymbProc(int64*,int64*,int64,chfac**);
void    iCopy(int64,int64*,int64*);

int64    OdAlloc(int64,int64,char*,order**);
void   OdFree(order**);
void   OdInit(order*,int64*);
void   OdIndex(order*,int64,int64);
void   OdProc(order*,xlist*,int64*,int64*,int64*,int64*,int64*,
              int64*,int64*,int64*,int64*,int64*,int64*,int64*,int64*);
int64    GetOrder(order*,int64*);

void   DotProd(double*,chfac*);

/* void   CfcInit(chfac*,symat*,double*); */
int64    ChlFact(chfac*,int64*,double*,int64);
void   copyChl(chfac *, chfac *);

/* void   PermSmatx(smatx*,int64*,int64*); */

int64    XtAlloc(int64,int64,char*,xlist**);
void   XtFree(xlist**);
int64    XtSucc(xlist*);
void   XtDel(xlist*,int64);
void   XtPut(xlist*,int64,int64);
int64    XtLeast(xlist*);
int64    XtGet(xlist*,int64*,int64*);

int64    IptAlloc(int64,int64,int64**,char*);
void   IptFree(int64,int64**);
int64    LocIntPos(int64,int64,int64*);
void   PermTransSym(int64,int64*,int64*,int64*,int64*,int64,int64*,int64*,int64*);

void   iZero(int64,int64*,int64*);
void   iFill(int64,int64,int64*,int64*,int64*);
void   iSwap(int64,int64,int64*);
void   iCopy(int64,int64*,int64*);
int64    iSum(int64,int64*);
void   dZero(int64,double*,int64*,int64*);
void   dCopy(int64,double*,double*);
void   dCat(int64,int64*,double*,double*);
double dSum(int64,double*);
void   PlusByOne(int64,int64*,int64*,int64*);

void iSet(int64, int64, int64 *, int64 *);
void plusXs(int64, int64*, int64*);

int64 MatMult4(chfac *,double *,double*,int64);
int64 Mat4LogDet(chfac *,double *);
int64 MatZeroEntries4(chfac *);
int64 MatSolve4(chfac *,double *,double*,int64);
void  CfcFree(chfac**);
int64 MatSetColumn4(chfac *, double *, int64);
int64 MatAddColumn4(chfac *, double,double *, int64);
int64 MchlSetup2(int64 m, chfac** A);
int64 MatSetValue4(chfac *, int64,int64,double, int64);
int64 Mat4GetDiagonal(chfac*, double *,int64);
int64 Mat4SetDiagonal(chfac*, double *,int64);
int64 Mat4AddDiagonal(chfac*, double *,int64);
int64 MatAddDiagonalElement(chfac*,int64, double);
int64 Mat4View(chfac *);
int64 Mat4DiagonalShift(chfac*, double);
